Subject: Re: [PATCH] kbuild, sparseirq: work around GCC bug with __weak aliases

From: Paul Mackerras <[email-masked]>
Date: Sat, 27 Dec 2008 15:09:44 +1100

Ingo Molnar writes:

> * Ingo Molnar <[email-masked]> wrote:
> 
> > > I recall David Howells had a similar issue with the bootparamter patch 
> > > set. The workaround he used was to add a barrier(); call in the weak 
> > > function to avoid the inline.
> > 
> > could we add some extra attribute to __weak that would have a similar 
> > effect? Something like __attribute__((noinline)), or something silly 
> > like __attribute__((deprecated)) - just to keep gcc from screwing up 
> > __weak functions? Perhaps adding a section attribute would have a 
> > similar effect? (putting weak definitions into an extra section is 
> > probably helpful anyway)
> 
> I've applied the patch below to tip/irq/sparseirq - could someone with an 
> affected GCC version please check whether this solves the crash?

I recall from discussions earlier that noinline doesn't fix the
problem, and I just tested a similar case and verified that adding
noinline doesn't stop some versions of gcc from inlining them.  The
empty weak functions in kernel/perf_counter.c were getting inlined by
the cross-gcc (gcc 4.1.1) I use for compiling powerpc kernels on my
laptop, and adding noinline doesn't help there.

Paul.